<?php

// Make results table
// (c) Peter Kankowski, 2008

$columns = array();
$urls = array(
	'Bernstein' => 'http://www.cse.yorku.ca/~oz/hash.html#djb2',
	'x65599' => 'http://www.cse.yorku.ca/~oz/hash.html#sdbm',
	'FNV-1a' => 'http://isthe.com/chongo/tech/comp/fnv/',
	'Larson' => 'http://research.microsoft.com/~PALARSON/',
	'Paul Hsieh' => 'http://www.azillionmonkeys.com/qed/hash.html',
	'One At Time' => 'http://www.burtleburtle.net/bob/hash/doobs.html',
	'lookup3'     => 'http://www.burtleburtle.net/bob/hash/doobs.html',
	'Arash Partow' => 'http://www.partow.net/programming/hashfunctions/',
	'Fletcher' => "http://en.wikipedia.org/wiki/Fletcher's_checksum",
	'Murmur2' => 'http://murmurhash.googlepages.com/MurmurHash2.cpp',
	'Hanson' => 'http://code.google.com/p/cii/source/browse/tags/v20/src/atom.c',
	'MaPrime2c' => 'http://amsoftware.narod.ru/algo.html',
	'SBox' => 'http://home.comcast.net/~bretm/hash/10.html',
	'Novak unrolled' => 'http://www.strchr.com/hash_functions?allcomments=1#comment_363',
	'Meiyan' => 'http://www.sanmayce.com/Fastest_Hash/',
	'Murmur3' => 'http://code.google.com/p/smhasher/',
	'XXHfast32' => 'http://code.google.com/p/xxhash/',
);
$rows = array();
$times = array();
$collisions = array();
$min_times = array();
$min_collisions = array();

$lines = file('test_results.txt');

foreach($lines as $line) {
    if(preg_match('/\| +(\d+) \[ *(\d+)\]/', $line, $match)) {
       $rows[$cur_row] = trim(substr($line, 0, strcspn($line, ':')));
       array_push($times[$cur_col], $match[1]);
       array_push($collisions[$cur_col], $match[2]);
       $min_times[$cur_col] = min($min_times[$cur_col], $match[1]);
       $min_collisions[$cur_col] = min($min_collisions[$cur_col], $match[2]);
       $cur_row++;
    } else if(0 == strspn($line, "1234567890")) { # skip the "lines read" and "elements in the table" lines
       $cur_row = 0;
       array_push($columns, rtrim($line));
       array_push($times, array());
       array_push($min_times, 2147483647); // the maximum integer number
       array_push($min_collisions, 2147483647);
       $cur_col = array_push($collisions, array()) - 1;
    }
}

# Add URLs
foreach($rows as &$name)
	if (isset($urls[$name]))
		$name = '<a href="' . $urls[$name] . '">' . $name . '</a>';

# Average of normalized values
$times_sum = array();
$collisions_sum = array();
for($i = 0; $i < count($rows); $i++) {
	$times_sum[$i] = 0;
	$collisions_sum[$i] = 0;
	for ($j = 0; $j < count($columns); $j++) {
		$times_sum[$i] += $times[$j][$i] / $min_times[$j];
		$collisions_sum[$i] += $collisions[$j][$i] / $min_collisions[$j];
	}
	$times_sum[$i] = sprintf('%.2f', $times_sum[$i] / count($columns));
	$collisions_sum[$i] = sprintf('%.2f', $collisions_sum[$i] / count($columns));
}

// Average
array_push($columns, 'Avg');
array_push($times, $times_sum);
$cur_col = array_push($collisions, $collisions_sum) - 1;

// Sort each column of "time" and "collisions" arrays
$times_list = '';
$collisions_list = '';
for($i = 0; $i < $cur_col; $i++) {
	$times_list .= '$times[' . $i . '], ';
	$collisions_list .= '$collisions[' . $i . '], ';
}
eval('array_multisort($times[$cur_col], $collisions[$cur_col], ' . $times_list . $collisions_list . '$rows);');


?><style><!--
table{text-align:right}
th{text-align:center}
.collisions {color:#999}
--></style><?php
echo '<table>';
echo '<tr><th></th><th colspan="2">' . implode('</th><th colspan="2">', $columns) . "</th></tr>\r\n";
for($i = 0; $i < count($rows); $i++) {
    echo '<tr><td class="l">' . $rows[$i] . '</td>';
    for($j = 0; $j < count($columns); $j++) {
        echo '<td>' . $times[$j][$i] . '</td>'.
             '<td><small class="collisions">[' . $collisions[$j][$i] . ']</small></td>';
    }
    echo "</tr>\r\n";
}
echo '</table>';

?>