import sys, re, urllib.parse, math, subprocess

series = []
labels = ''
min_value = 1000000000
max_value = 0

# modified from http://code.google.com/apis/chart/docs/data_formats.html#encoding_data
def extended_encode(num_data, min_value, max_value):
	MAP = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-.'
	encoded = ''
	for num in num_data:
		scaled = len(MAP) * len(MAP) * (num - min_value) // (max_value - min_value)
		if scaled > len(MAP) * len(MAP) - 1:
			encoded += '..'
		elif scaled < 0:
			encoded += '__'
		else:
			encoded += MAP[scaled // len(MAP)] + MAP[scaled % len(MAP)]
	return encoded

out = subprocess.check_output(['release/hash', '/c', 'exdic_wikipedia.txt']).decode(sys.stdin.encoding)
for line in out.split('\r\n'):
	m = re.match(r'\s*(.+): ([0-9 ]+)$', line)
	if m:
		labels += urllib.parse.quote_plus(m.group(1)) + '|'
		data = m.group(2).split()
		num_data = list(map(int, data))
		min_value = min(min_value, min(num_data))
		max_value = max(max_value, max(num_data))
		num_data.reverse()
		series.append(num_data)
	elif line.startswith('     '):
		bits = line.split()

encoded = ''
for s in series:
	encoded += extended_encode(s, min_value, max_value) + ','

print('http://chart.apis.google.com/chart?cht=lc&chs=400x600' + \
	'&chtt=' + urllib.parse.quote_plus('Number of collisions / number of used bits') + \
	'&chxt=x,y&chxr=0,' + bits[-1] + ',' + bits[0] + '|' +
	'1,' + str(min_value) + ',' + str(max_value) +
	'&chco=cfcfcf,c1c1c1,ff00cc,d2d2d2,c5c5c5,D0D0D0,FF0000,c0c0c0,' + \
	'FFFF00,C6C6C6,c7c7c7,c2c2c2,c4c4c4,CDCDCD,336600,c8c8c8,C3C3C3,111ca4,C0C0C0,D0D0D0,C0C0C0,C5C5C5,D1D1D1' + \
	'&chdl=' + labels.rstrip('|') + \
	'&chd=e:' + encoded.rstrip(','))
